---
- name: create raw disk file
  command: "dd if=/dev/zero of=/{{ disk_name }} bs=1M count={{ disk_size }}"
  args:
    creates: "/{{ disk_name }}"
  become: true

- name: make sure a loopdevice exists
  command: mknod /dev/loop0 b 7 0
  args:
    creates: /dev/loop0
  become: true

- name: get loop device if exists
  shell: |
    set -o pipefail
    losetup --list | grep vd01 | awk '{ print $1 }'
  register: loopdevice
  failed_when: false
  ignore_errors: true
  changed_when: false
  become: true

- name: configure loop device
  command: "losetup -f /{{ disk_name }} -P --show"
  when: loopdevice.stdout.find("loop") == -1
  become: true

- name: get loop device name
  shell: |
    set -o pipefail
    losetup --list | grep {{ disk_name }} | awk '{ print $1 }'
  register: loopdevice_used
  failed_when: false
  ignore_errors: true
  changed_when: false
  become: true

- name: set loopdevice fact
  set_fact:
    loop_device: "{{ loopdevice_used.stdout }}"
  become: true
